## mingw-w64-libadalang-tools-26.0.0-1.src.tar.zst

=== Makefile ===
# To build in production mode, do  "make LIBRARY_TYPE=static BUILD_MODE=prod".
# To build in development mode, do "make LIBRARY_TYPE=static BUILD_MODE=dev".

BUILD_MODE ?= dev
LIBRARY_TYPE ?= static
LALTOOLS_SET ?= all
PROCESSORS ?= 0
BUILD_ROOT ?=

ALL_LIBRARY_TYPES = static static-pic relocatable
ALL_BUILD_MODES = dev prod AddressSanitizer

LIB_PROJECTS = \
	src/lal_tools.gpr

BIN_PROJECTS = \
	src/build.gpr

TESTSUITE_PROJECTS ?= \
	testsuite/ada_drivers/indent/indent.gpr \
	testsuite/ada_drivers/outgoing_calls/outgoing_calls.gpr \
	testsuite/ada_drivers/partial_gnatpp/partial_gnatpp.gpr

ALL_PROJECTS = \
	$(BIN_PROJECTS) $(LIB_PROJECTS) $(TESTSUITE_PROJECTS)

ifeq ($(BUILD_ROOT),)
RELOCATE_BUILD=
BIN=bin
else
# build artifacts are relocated to $(BUILD_ROOT)
RELOCATE_BUILD=--relocate-build-tree="$(BUILD_ROOT)" --root-dir=.
BIN=$(BUILD_ROOT)/bin
endif

GPRBUILD = gprbuild -v -k -p -j$(PROCESSORS) $(RELOCATE_BUILD)

.PHONY: all
all:
	which gprbuild
	which gcc
	for proj in $(ALL_PROJECTS) ; do \
		$(GPRBUILD) \
			-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XXMLADA_BUILD=$(LIBRARY_TYPE) \
			-XLALTOOLS_BUILD_MODE=$(BUILD_MODE) \
			-XLALTOOLS_SET=$(LALTOOLS_SET) \
			-P $$proj ; \
	done

.PHONY: lib
lib:
	which gprbuild
	which gcc
	for proj in $(LIB_PROJECTS) ; do \
		for kind in $(ALL_LIBRARY_TYPES) ; do \
			rm -f obj/lib/$$kind/*.lexch; \
			$(GPRBUILD) \
				-XLIBRARY_TYPE=$$kind \
				-XLALTOOLS_BUILD_MODE=$(BUILD_MODE) \
				-P $$proj ; \
		done ; \
	done

.PHONY: bin
bin:
	which gprbuild
	which gcc
	for proj in $(BIN_PROJECTS) ; do \
		$(GPRBUILD) \
			-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XXMLADA_BUILD=$(LIBRARY_TYPE) \
			-XLALTOOLS_BUILD_MODE=$(BUILD_MODE) \
			-XLALTOOLS_SET=$(LALTOOLS_SET) \
			-P $$proj ; \
	done

.PHONY: testsuite_drivers
testsuite_drivers:
	which gprbuild
	which gcc
	for proj in $(TESTSUITE_PROJECTS) ; do \
		$(GPRBUILD) \
			-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XXMLADA_BUILD=$(LIBRARY_TYPE) \
			-XLALTOOLS_BUILD_MODE=$(BUILD_MODE) \
			-XLALTOOLS_SET=$(LALTOOLS_SET) \
			-P $$proj ; \
	done

.PHONY: test
test: all
	$(BIN)/utils-var_length_ints-test
	testsuite/testsuite.py

.PHONY: clean
clean:
	for proj in $(ALL_PROJECTS) ; do \
		for build_mode in $(ALL_BUILD_MODES) ; do \
			for library_type in $(ALL_LIBRARY_TYPES) ; do \
				gprclean $(RELOCATE_BUILD) \
					-XLIBRARY_TYPE=$$library_type \
					-XLALTOOLS_BUILD_MODE=$$build_mode \
					-q -P $$proj; \
			done ; \
		done ; \
	done

.PHONY: install-lib
install-lib:
	for proj in $(LIB_PROJECTS) ; do \
		for kind in $(ALL_LIBRARY_TYPES) ; do \
			gprinstall $(RELOCATE_BUILD) \
				-XLIBRARY_TYPE=$$kind \
				-XLALTOOLS_BUILD_MODE=$(BUILD_MODE) \
				--prefix="$(DESTDIR)" \
				--sources-subdir=include/$$(basename $$proj | cut -d. -f1) \
				--build-name=$$kind \
				--build-var=LIBRARY_TYPE --build-var=LAL_TOOLS_BUILD \
				-P $$proj -p -f ; \
		done ; \
	done

.PHONY: install-bin-strip
install-bin-strip:
	mkdir -p "$(DESTDIR)"
	cp -r "$(BIN)" "$(DESTDIR)/"
	# Don't strip debug builds
	test "$(BUILD_MODE)" = dev || strip "$(DESTDIR)/bin/"*

.PHONY: install-tgen
install-tgen:
	mkdir -p "$(DESTDIR)/share/tgen"
	cp -r src/tgen/tgen_rts "$(DESTDIR)/share/tgen/"
	cp -r share/tgen/templates "$(DESTDIR)/share/tgen/"

=== PKGBUILD ===
# Maintainer: Philipp Smirnov https://github.com/sad-poet

_realname=libadalang-tools
pkgbase=mingw-w64-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_realname}
pkgver=26.0.0
pkgrel=1
pkgdesc="Libadalang-based tools for Ada: gnatpp, gnatmetric, gnatstub and gnattest (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url="https://github.com/AdaCore/libadalang-tools"
msys2_references=(
  'aur: libadalang-tools'
  'gentoo: dev-ada/libadalang-tools'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-libadalang"
         "${MINGW_PACKAGE_PREFIX}-gcc-ada"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gnatcoll-core"
         "${MINGW_PACKAGE_PREFIX}-gnatcoll-gmp"
         "${MINGW_PACKAGE_PREFIX}-gnatcoll-iconv"
         "${MINGW_PACKAGE_PREFIX}-gpr"
         "${MINGW_PACKAGE_PREFIX}-langkit_support"
         "${MINGW_PACKAGE_PREFIX}-libgpr"
         "${MINGW_PACKAGE_PREFIX}-templates-parser"
         "${MINGW_PACKAGE_PREFIX}-xmlada")
makedepends=("${MINGW_PACKAGE_PREFIX}-gprbuild")
source=("https://github.com/AdaCore/libadalang-tools/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('52b59242a3cd522f5ad72022a5714d6f2858325544e2896f7863e990322a94dc')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}/"
  build_year=$(LANG=C date "+%Y")
  sed -i 's/:= "dev";/:= "'"${pkgver}"'";/' "src/utils-versions.ads"
  sed -i 's/:= "unknown";/:= "'"${build_year}"'";/' "src/utils-versions.ads"
}

build() {
  [[ -d "${srcdir}"/build-${MSYSTEM} ]] && rm -rf "${srcdir}"/build-${MSYSTEM}
  cp -r "${srcdir}/${_realname}-${pkgver}" "${srcdir}"/build-${MSYSTEM}
  cd "${srcdir}"/build-${MSYSTEM}

  BUILD_MODE=prod \
  LIBRARY_TYPE=relocatable \
  make lib bin
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}

  BUILD_MODE=prod \
  LIBRARY_TYPE=relocatable \
  make DESTDIR="${pkgdir}${MINGW_PREFIX}" install-lib install-bin-strip

  install -Dm644 -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}" \
    "${srcdir}/${_realname}-${pkgver}"/LICENSE
}
